---
variables:
  TERRAFORM_VERSION: 0.10.3

stages:
  - check
  - build
  - validate-stack
  - deploy-dev

check-js:
  stage: check
  image: node:6-alpine
  before_script:
    - npm install
  script:
    - npm run lint
    - npm run test
  tags:
    - docker

build-js:
  stage: build
  image: node:6-alpine
  before_script:
    - apk --update add zip
    - npm install --production
  script:
    - zip -r code.zip *.js node_modules -x "*aws-sdk*"
  artifacts:
    paths:
      - code.zip
    expire_in: 1 day
  tags:
    - docker

validate-terraform:
  stage: validate-stack
  image: node:6-alpine
  variables:
    TF_VAR_core_region: eu-west-1
    TF_VAR_env: dev
    TF_VAR_iam_for_sfn: arn:aws:iam::620702670119:user/vandana.gaikwad
  before_script:
    - apk --update add openssl ca-certificates
    - update-ca-certificates
    - wget https://releases.hashicorp.com/terraform/${TERRAFORM_VERSION}/terraform_${TERRAFORM_VERSION}_linux_386.zip
    - unzip terraform*
  script:
    - ./terraform init 
    - ./terraform validate
  dependencies:
    - build-js
  tags:
    - docker

terraform-dev:
  stage: deploy-dev 
  image: node:6-alpine 
  variables:
    TF_VAR_core_region: eu-central-1
    TF_VAR_env: dev
    TF_VAR_iam_for_sfn: arn:aws:iam::620702670119:user/vandana.gaikwad
  before_script:
    - apk --update add openssl ca-certificates
    - update-ca-certificates
    - wget https://releases.hashicorp.com/terraform/${TERRAFORM_VERSION}/terraform_${TERRAFORM_VERSION}_linux_386.zip
    - unzip terraform*
    - echo 'testing'
  script:
    - ./terraform init 
    - ./terraform plan 
    - ./terraform apply      
  dependencies:
    - build-js
  tags:
    - docker
  only:
    - master
